export const IMREAD_UNCHANGED = -1;
export const IMREAD_GRAYSCALE = 0;
export const IMREAD_COLOR_BGR = 1;
export const IMREAD_COLOR = 1;
export const IMREAD_ANYDEPTH = 2;
export const IMREAD_ANYCOLOR = 4;
export const IMREAD_LOAD_GDAL = 8;
export const IMREAD_REDUCED_GRAYSCALE_2 = 16;
export const IMREAD_REDUCED_COLOR_2 = 17;
export const IMREAD_REDUCED_GRAYSCALE_4 = 32;
export const IMREAD_REDUCED_COLOR_4 = 33;
export const IMREAD_REDUCED_GRAYSCALE_8 = 64;
export const IMREAD_REDUCED_COLOR_8 = 65;
export const IMREAD_IGNORE_ORIENTATION = 128;
export const IMREAD_COLOR_RGB = 256;

export const CV_8U = 0;
export const CV_8S = 1;
export const CV_16U = 2;
export const CV_16S = 3;
export const CV_32S = 4;
export const CV_32F = 5;
export const CV_64F = 6;
export const CV_16F = 7;

const CV_CN_MAX = 512
const CV_CN_SHIFT = 3
const CV_DEPTH_MAX = (1 << CV_CN_SHIFT)
const CV_MAT_DEPTH_MASK = (CV_DEPTH_MAX - 1)
const CV_MAT_DEPTH = (flags: number) => ((flags) & CV_MAT_DEPTH_MASK)
const CV_MAKETYPE = (depth: number, cn: number) => (CV_MAT_DEPTH(depth) + (((cn) - 1) << CV_CN_SHIFT))

export const CV_8UC1 = CV_MAKETYPE(CV_8U, 1);
export const CV_8UC2 = CV_MAKETYPE(CV_8U, 2);
export const CV_8UC3 = CV_MAKETYPE(CV_8U, 3);
export const CV_8UC4 = CV_MAKETYPE(CV_8U, 4);
export const CV_8UC = (n: number) => CV_MAKETYPE(CV_8U, (n));

export const CV_8SC1 = CV_MAKETYPE(CV_8S, 1);
export const CV_8SC2 = CV_MAKETYPE(CV_8S, 2);
export const CV_8SC3 = CV_MAKETYPE(CV_8S, 3);
export const CV_8SC4 = CV_MAKETYPE(CV_8S, 4);
export const CV_8SC = (n: number) => CV_MAKETYPE(CV_8S, (n));

export const CV_16UC1 = CV_MAKETYPE(CV_16U, 1);
export const CV_16UC2 = CV_MAKETYPE(CV_16U, 2);
export const CV_16UC3 = CV_MAKETYPE(CV_16U, 3);
export const CV_16UC4 = CV_MAKETYPE(CV_16U, 4);
export const CV_16UC = (n: number) => CV_MAKETYPE(CV_16U, (n));

export const CV_16SC1 = CV_MAKETYPE(CV_16S, 1);
export const CV_16SC2 = CV_MAKETYPE(CV_16S, 2);
export const CV_16SC3 = CV_MAKETYPE(CV_16S, 3);
export const CV_16SC4 = CV_MAKETYPE(CV_16S, 4);
export const CV_16SC = (n: number) => CV_MAKETYPE(CV_16S, (n));

export const CV_32SC1 = CV_MAKETYPE(CV_32S, 1);
export const CV_32SC2 = CV_MAKETYPE(CV_32S, 2);
export const CV_32SC3 = CV_MAKETYPE(CV_32S, 3);
export const CV_32SC4 = CV_MAKETYPE(CV_32S, 4);
export const CV_32SC = (n: number) => CV_MAKETYPE(CV_32S, (n));

export const CV_32FC1 = CV_MAKETYPE(CV_32F, 1);
export const CV_32FC2 = CV_MAKETYPE(CV_32F, 2);
export const CV_32FC3 = CV_MAKETYPE(CV_32F, 3);
export const CV_32FC4 = CV_MAKETYPE(CV_32F, 4);
export const CV_32FC = (n: number) => CV_MAKETYPE(CV_32F, (n));

export const CV_64FC1 = CV_MAKETYPE(CV_64F, 1);
export const CV_64FC2 = CV_MAKETYPE(CV_64F, 2);
export const CV_64FC3 = CV_MAKETYPE(CV_64F, 3);
export const CV_64FC4 = CV_MAKETYPE(CV_64F, 4);
export const CV_64FC = (n: number) => CV_MAKETYPE(CV_64F, (n));

export const CV_16FC1 = CV_MAKETYPE(CV_16F, 1);
export const CV_16FC2 = CV_MAKETYPE(CV_16F, 2);
export const CV_16FC3 = CV_MAKETYPE(CV_16F, 3);
export const CV_16FC4 = CV_MAKETYPE(CV_16F, 4);
export const CV_16FC = (n: number) => CV_MAKETYPE(CV_16F, (n));


export const INTER_NEAREST = 0;
export const INTER_LINEAR = 1;
export const INTER_CUBIC = 2;
export const INTER_AREA = 3;
export const INTER_LANCZOS4 = 4;
export const INTER_LINEAR_EXACT = 5;
export const INTER_NEAREST_EXACT = 6;
export const INTER_MAX = 7;
export const WARP_FILL_OUTLIERS = 8;
export const WARP_INVERSE_MAP = 16;
export const WARP_RELATIVE_MAP = 32;


export const BORDER_CONSTANT = 0;
export const BORDER_REPLICATE = 1;
export const BORDER_REFLECT = 2;
export const BORDER_WRAP = 3;
export const BORDER_REFLECT_101 = 4;
export const BORDER_TRANSPARENT = 5;
export const BORDER_REFLECT101 = BORDER_REFLECT_101;
export const BORDER_DEFAULT = BORDER_REFLECT_101;
export const BORDER_ISOLATED = 16;

export const IMWRITE_JPEG_QUALITY = 1;
export const IMWRITE_JPEG_PROGRESSIVE = 2;
export const IMWRITE_JPEG_OPTIMIZE = 3;
export const IMWRITE_JPEG_RST_INTERVAL = 4;
export const IMWRITE_JPEG_LUMA_QUALITY = 5;
export const IMWRITE_JPEG_CHROMA_QUALITY = 6;
export const IMWRITE_JPEG_SAMPLING_FACTOR = 7;
export const IMWRITE_PNG_COMPRESSION = 16;
export const IMWRITE_PNG_STRATEGY = 17;
export const IMWRITE_PNG_BILEVEL = 18;
export const IMWRITE_PXM_BINARY = 32;
export const IMWRITE_EXR_TYPE = (3 << 4) + 0;
export const IMWRITE_EXR_COMPRESSION = (3 << 4) + 1;
export const IMWRITE_EXR_DWA_COMPRESSION_LEVEL = (3 << 4) + 2;
export const IMWRITE_WEBP_QUALITY = 64;
export const IMWRITE_HDR_COMPRESSION = (5 << 4) + 0;
export const IMWRITE_PAM_TUPLETYPE = 128;
export const IMWRITE_TIFF_RESUNIT = 256;
export const IMWRITE_TIFF_XDPI = 257;
export const IMWRITE_TIFF_YDPI = 258;
export const IMWRITE_TIFF_COMPRESSION = 259;
export const IMWRITE_TIFF_ROWSPERSTRIP = 278;
export const IMWRITE_TIFF_PREDICTOR = 317;
export const IMWRITE_JPEG2000_COMPRESSION_X1000 = 272;
export const IMWRITE_AVIF_QUALITY = 512;
export const IMWRITE_AVIF_DEPTH = 513;
export const IMWRITE_AVIF_SPEED = 514;
export const IMWRITE_JPEGXL_QUALITY = 640;
export const IMWRITE_JPEGXL_EFFORT = 641;
export const IMWRITE_JPEGXL_DISTANCE = 642;
export const IMWRITE_JPEGXL_DECODING_SPEED = 643;
export const IMWRITE_GIF_LOOP = 1024;
export const IMWRITE_GIF_SPEED = 1025;
export const IMWRITE_GIF_QUALITY = 1026;
export const IMWRITE_GIF_DITHER = 1027;
export const IMWRITE_GIF_TRANSPARENCY = 1028;
export const IMWRITE_GIF_COLORTABLE = 1029;

export const FILLED = -1;
export const LINE_4 = 4;
export const LINE_8 = 8;
export const LINE_AA = 16;


export const FONT_HERSHEY_SIMPLEX = 0;
export const FONT_HERSHEY_PLAIN = 1;
export const FONT_HERSHEY_DUPLEX = 2;
export const FONT_HERSHEY_COMPLEX = 3;
export const FONT_HERSHEY_TRIPLEX = 4;
export const FONT_HERSHEY_COMPLEX_SMALL = 5;
export const FONT_HERSHEY_SCRIPT_SIMPLEX = 6;
export const FONT_HERSHEY_SCRIPT_COMPLEX = 7;
export const FONT_ITALIC = 16;


export const MARKER_CROSS = 0;
export const MARKER_TILTED_CROSS = 1;
export const MARKER_STAR = 2;
export const MARKER_DIAMOND = 3;
export const MARKER_SQUARE = 4;
export const MARKER_TRIANGLE_UP = 5;
export const MARKER_TRIANGLE_DOWN = 6;


export const CAP_ANY = 0;
export const CAP_VFW = 200;
export const CAP_V4L = 200;
export const CAP_V4L2 = CAP_V4L;
export const CAP_FIREWIRE = 300;
export const CAP_FIREWARE = CAP_FIREWIRE;
export const CAP_IEEE1394 = CAP_FIREWIRE;
export const CAP_DC1394 = CAP_FIREWIRE;
export const CAP_CMU1394 = CAP_FIREWIRE;
export const CAP_QT = 500;
export const CAP_UNICAP = 600;
export const CAP_DSHOW = 700;
export const CAP_PVAPI = 800;
export const CAP_OPENNI = 900;
export const CAP_OPENNI_ASUS = 910;
export const CAP_ANDROID = 1000;
export const CAP_XIAPI = 1100;
export const CAP_AVFOUNDATION = 1200;
export const CAP_GIGANETIX = 1300;
export const CAP_MSMF = 1400;
export const CAP_WINRT = 1410;
export const CAP_INTELPERC = 1500;
export const CAP_REALSENSE = 1500;
export const CAP_OPENNI2 = 1600;
export const CAP_OPENNI2_ASUS = 1610;
export const CAP_OPENNI2_ASTRA = 1620;
export const CAP_GPHOTO2 = 1700;
export const CAP_GSTREAMER = 1800;
export const CAP_FFMPEG = 1900;
export const CAP_IMAGES = 2000;
export const CAP_ARAVIS = 2100;
export const CAP_OPENCV_MJPEG = 2200;
export const CAP_INTEL_MFX = 2300;
export const CAP_XINE = 2400;
export const CAP_UEYE = 2500;
export const CAP_OBSENSOR = 2600;

export const CAP_PROP_POS_MSEC = 0;
export const CAP_PROP_POS_FRAMES = 1;
export const CAP_PROP_POS_AVI_RATIO = 2;
export const CAP_PROP_FRAME_WIDTH = 3;
export const CAP_PROP_FRAME_HEIGHT = 4;
export const CAP_PROP_FPS = 5;
export const CAP_PROP_FOURCC = 6;
export const CAP_PROP_FRAME_COUNT = 7;
export const CAP_PROP_FORMAT = 8;
export const CAP_PROP_MODE = 9;
export const CAP_PROP_BRIGHTNESS = 10;
export const CAP_PROP_CONTRAST = 11;
export const CAP_PROP_SATURATION = 12;
export const CAP_PROP_HUE = 13;
export const CAP_PROP_GAIN = 14;
export const CAP_PROP_EXPOSURE = 15;
export const CAP_PROP_CONVERT_RGB = 16;
export const CAP_PROP_WHITE_BALANCE_BLUE_U = 17;
export const CAP_PROP_RECTIFICATION = 18;
export const CAP_PROP_MONOCHROME = 1;
export const CAP_PROP_SHARPNESS = 2;
export const CAP_PROP_AUTO_EXPOSURE = 21;
export const CAP_PROP_GAMMA = 2;
export const CAP_PROP_TEMPERATURE = 2;
export const CAP_PROP_TRIGGER = 2;
export const CAP_PROP_TRIGGER_DELAY = 2;
export const CAP_PROP_WHITE_BALANCE_RED_V = 2;
export const CAP_PROP_ZOOM = 2;
export const CAP_PROP_FOCUS = 2;
export const CAP_PROP_GUID = 2;
export const CAP_PROP_ISO_SPEED = 3;
export const CAP_PROP_BACKLIGHT = 3;
export const CAP_PROP_PAN = 3;
export const CAP_PROP_TILT = 3;
export const CAP_PROP_ROLL = 3;
export const CAP_PROP_IRIS = 3;
export const CAP_PROP_SETTINGS = 37;
export const CAP_PROP_BUFFERSIZE = 3;
export const CAP_PROP_AUTOFOCUS = 3;
export const CAP_PROP_SAR_NUM = 40;
export const CAP_PROP_SAR_DEN = 41;
export const CAP_PROP_BACKEND = 42;
export const CAP_PROP_CHANNEL = 43;
export const CAP_PROP_AUTO_WB = 44;
export const CAP_PROP_WB_TEMPERATURE = 45;
export const CAP_PROP_CODEC_PIXEL_FORMAT = 46;
export const CAP_PROP_BITRATE = 47;
export const CAP_PROP_ORIENTATION_META = 48;
export const CAP_PROP_ORIENTATION_AUTO = 49;
export const CAP_PROP_HW_ACCELERATION = 50;
export const CAP_PROP_HW_DEVICE = 51;
export const CAP_PROP_HW_ACCELERATION_USE_OPENCL = 52;
export const CAP_PROP_OPEN_TIMEOUT_MSEC = 53;
export const CAP_PROP_READ_TIMEOUT_MSEC = 54;
export const CAP_PROP_STREAM_OPEN_TIME_USEC = 55;
export const CAP_PROP_VIDEO_TOTAL_CHANNELS = 5;
export const CAP_PROP_VIDEO_STREAM = 5;
export const CAP_PROP_AUDIO_STREAM = 5;
export const CAP_PROP_AUDIO_POS = 5;
export const CAP_PROP_AUDIO_SHIFT_NSEC = 6;
export const CAP_PROP_AUDIO_DATA_DEPTH = 6;
export const CAP_PROP_AUDIO_SAMPLES_PER_SECOND = 6;
export const CAP_PROP_AUDIO_BASE_INDEX = 6;
export const CAP_PROP_AUDIO_TOTAL_CHANNELS = 6;
export const CAP_PROP_AUDIO_TOTAL_STREAMS = 6;
export const CAP_PROP_AUDIO_SYNCHRONIZE = 6;
export const CAP_PROP_LRF_HAS_KEY_FRAME = 6;
export const CAP_PROP_CODEC_EXTRADATA_INDEX = 6;
export const CAP_PROP_FRAME_TYPE = 6;
export const CAP_PROP_N_THREADS = 7;
export const CAP_PROP_PTS = 7;
export const CAP_PROP_DTS_DELAY = 7;
