import { CVVideoCapture } from "./addon";
import { __Mat } from "./common";
import { CAP_ANY } from "./consts";

export class VideoCapture {
	#cap: any

	constructor(source: string | number, apiPreference?: number, params?: number[]) {
		const CVCap = CVVideoCapture();
		if ((source as any) instanceof CVCap) this.#cap = source;
		else this.#cap = new CVCap(source, apiPreference ?? CAP_ANY, params ?? []);
	}

	private get __cap__() { return this.#cap; }

	public open(source: string | number, apiPreference?: number, params?: number[]): boolean { return this.#cap.Open(source, apiPreference ?? CAP_ANY, params ?? []); }
	public get isOpened(): boolean { return this.#cap.IsOpened(); }

	public grab(): boolean { return this.#cap.Grab(); }

	public retrieve(flag?: number) { return __Mat(this.#cap.Retrieve(flag ?? 0)); }
	public read() { return __Mat(this.#cap.Read()); }

	public get backendName(): string { return this.#cap.GetBackendName(); }

	public prop(propId: number, value: number): void
	public prop(propId: number): number
	public prop(propId: number, value?: number) {
		if (typeof value === "undefined") return this.#cap.Get(propId);
		else this.#cap.Set(propId, value);
	}

}
